package com.weaver.seconddev.interfaces.workflow.action;

import java.text.SimpleDateFormat;
import  com.weaver.seconddev.interfaces.oames.CallMesNewMaterialProjectService;
import  com.weaver.seconddev.interfaces.oames.OA_KSJXCL_SERVICEStub;
import  com.weaver.seconddev.interfaces.swfa.BillFieldUtil;
import com.weaver.common.i18n.tool.util.I18nContextUtil;
import com.weaver.verupgrade.conn.CONN_TYPE;
import java.lang.*;
import java.util.*;
import com.weaver.verupgrade.workflow.request.RequestManager;
import com.weaver.esb.api.rpc.EsbServerlessRpcRemoteInterface;
import com.weaver.common.base.entity.result.WeaResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import com.weaver.verupgrade.soa.workflow.request.RequestInfo;
import java.util.Map;
import java.util.HashMap;
import com.weaver.verupgrade.conn.RecordSet;
import com.weaver.verupgrade.general.BaseBean;
import com.weaver.verupgrade.general.Util;
import com.weaver.verupgrade.hrm.resource.ResourceComInfo;
import com.weaver.verupgrade.soa.workflow.request.Property;
import com.weaver.verupgrade.interfaces.workflow.action.Action;

/**
 * HTGD-JS04新材料立项流程
 */
@org.springframework.stereotype.Service("workflow_action_OaMesNewMaterialProjectAction")
public class OaMesNewMaterialProjectAction extends BaseBean implements Action, EsbServerlessRpcRemoteInterface {

    // 对应E9的请求信息对象
    @Autowired
    private RequestInfo requestInfoTemp;

    private static final Logger logger_fedc85f2 = LoggerFactory.getLogger(OaMesNewMaterialProjectAction.class);

    public WeaResult<Map<String, Object>> execute(Map<String, Object> requestInfoMap) {
        Map<String, Object> weaverResultMap = new HashMap<>();
        Long requestIdTemp = Long.parseLong(String.valueOf(requestInfoMap.getOrDefault("requestid", -1)));
        Long userIdTemp = Long.parseLong(String.valueOf(requestInfoMap.getOrDefault("userid", -1)));
        RequestInfo request = requestInfoTemp.getRequestInfo(requestIdTemp, userIdTemp);
        try {
            try {
                // 申请部门
                String sqbm = "";
                // 流程编号
                String lcbh = "";
                // 填表日期
                String tbrq = "";
                // 物料号
                String wlh = "";
                // 项目类别
                String xmlb = "";
                // 项目预计完成时间
                String xmyjwcsj = "";
                // 周期
                String zq = "";
                // 项目责任人
                String xmzrr = "";
                // 试制是否与材料检测同步进行
                String szsftbjx = "";
                // 原因说明
                String yysm = "";
                // 新材料物料信息
                String xclwlxx = "";
                // 认证内容（关键技术、特色和创新之处）
                String rznr = "";
                // 需求来源及实施所需条件
                String xqly = "";
                // 预期产品（项目）特性及材料应用方案
                String yqcp = "";
                // 预期经济效益（销售收入、成本节约）
                String yqjj = "";
                // 设备工装投资
                String sbgztz = "";
                // 材料投资
                String cltz = "";
                // 人工投资
                String rgtz = "";
                // 水电投资
                String sdtz = "";
                // 其他投资
                String qttz = "";
                // 合计总投资
                String hjztz = "";
                // 需求到货时间
                String xqdhsj = "";
                // 需求到货周期
                String xqdhzq = "";
                // 需求材料数量
                String xqclsl = "";
                // 新材料名称
                String xclmc = "";
                // 新材料型号规格
                String clxhgg = "";
                // 需求项目名称
                String xuqxmmc = "";
                // 需求项目单号
                String xqxmdh = "";
                // 建议供应商1
                String jygys1 = "";
                // 建议供应商2
                String jygys2 = "";
                // 建议供应商3
                String jygys3 = "";
                // 建议供应商4
                String jygys4 = "";
                // 建议供应商5
                String jygys5 = "";
                // 建议供应商6
                String jygys6 = "";
                // 物料特征值
                String wltzz = "";
                // 项目接收人
                String xmjsr = "";
                // 项目参与人
                String xmcyr = "";
                // 项目申请人
                String xmsqr = "";
                // 申请人姓名
                String sqrxm = "";
                String cpmc = "";
                Date now = new Date();
                SimpleDateFormat datetype = new SimpleDateFormat("yyyy-MM-dd");
                tbrq = datetype.format(now);
                // 流程请求ID
                String requestId = request.getRequestid();
                // 工作流ID
                String id = request.getWorkflowid();
                // 主表字段赋值
                logger_fedc85f2.error(String.valueOf("开始获取主表信息"));
                // 获取表单主字段信息
                Property[] properties = request.getMainTableInfo().getProperty();
                for (int i = 0; i < properties.length; i++) {
                    // 主表数据
                    // 字段名
                    String name = properties[i].getName().toLowerCase();
                    // 值
                    String value = Util.null2String(properties[i].getValue());
                    if (name.equals("sqbm")) {
                        // 申请部门
                        sqbm = value;
                    }
                    if (name.equals("lcbh")) {
                        // 流程编号
                        lcbh = value;
                    }
                    if (name.equals("tbrq")) {
                        // 填表日期
                        tbrq = value;
                    }
                    if (name.equals("wlh")) {
                        // 物料号
                        wlh = value;
                    }
                    if (name.equals("xmlb")) {
                        // 项目类别
                        xmlb = value;
                    }
                    if (name.equals("cpmc")) {
                        // 项目类别
                        cpmc = value;
                    }
                    if (name.equals("xmyjwcsj")) {
                        // 项目预计完成时间
                        xmyjwcsj = value;
                    }
                    if (name.equals("zq")) {
                        // 周期
                        zq = value;
                    }
                    if (name.equals("xmzrr")) {
                        // 项目责任人
                        xmzrr = value;
                    }
                    if (name.equals("szsftbjx")) {
                        // 试制是否与材料检测同步进行
                        szsftbjx = value;
                    }
                    if (name.equals("yysm")) {
                        // 原因说明
                        yysm = value.trim();
                    }
                    if (name.equals("xclwlxx")) {
                        // 新材料物料信息
                        xclwlxx = value.trim();
                    }
                    if (name.equals("rznr")) {
                        // 认证内容（关键技术、特色和创新之处）
                        rznr = value.trim();
                    }
                    if (name.equals("xqly")) {
                        // 需求来源及实施所需条件
                        xqly = value.trim();
                    }
                    if (name.equals("yqcp")) {
                        // 预期产品（项目）特性及材料应用方案
                        yqcp = value.trim();
                    }
                    if (name.equals("yqjj")) {
                        // 预期经济效益（销售收入、成本节约）
                        yqjj = value.trim();
                    }
                    if (name.equals("sbgztz")) {
                        // 设备工装投资
                        sbgztz = value;
                    }
                    if (name.equals("cltz")) {
                        // 材料投资
                        cltz = value;
                    }
                    if (name.equals("rgtz")) {
                        // 人工投资
                        rgtz = value;
                    }
                    if (name.equals("sdtz")) {
                        // 水电投资
                        sdtz = value;
                    }
                    if (name.equals("qttz")) {
                        // 其他投资
                        qttz = value;
                    }
                    if (name.equals("hjztz")) {
                        // 合计总投资
                        hjztz = value;
                    }
                    if (name.equals("xqdhsj")) {
                        // 需求到货时间
                        xqdhsj = value;
                    }
                    if (name.equals("xqdhzq")) {
                        // 需求到货周期
                        xqdhzq = value;
                    }
                    if (name.equals("xqclsl")) {
                        // 需求材料数量
                        xqclsl = value;
                    }
                    if (name.equals("xclmc")) {
                        // 新材料名称
                        xclmc = value.trim();
                    }
                    if (name.equals("clxhgg")) {
                        // 新材料型号规格
                        clxhgg = value.trim();
                    }
                    if (name.equals("xuqxmmc")) {
                        // 需求项目名称
                        xuqxmmc = value.trim();
                    }
                    if (name.equals("xqxmdh")) {
                        // 需求项目单号
                        xqxmdh = value.trim();
                    }
                    if (name.equals("jygys1")) {
                        // 建议供应商1
                        jygys1 = value.trim();
                    }
                    if (name.equals("jygys2")) {
                        // 建议供应商2
                        jygys2 = value.trim();
                    }
                    if (name.equals("jygys3")) {
                        // 建议供应商3
                        jygys3 = value.trim();
                    }
                    if (name.equals("jygys4")) {
                        // 建议供应商4
                        jygys4 = value.trim();
                    }
                    if (name.equals("jygys5")) {
                        // 建议供应商5
                        jygys5 = value.trim();
                    }
                    if (name.equals("jygys6")) {
                        // 建议供应商6
                        jygys6 = value.trim();
                    }
                    if (name.equals("wltzz")) {
                        // 物料特征值
                        wltzz = value.trim();
                    }
                    if (name.equals("xmjsr")) {
                        // 项目接收人
                        xmjsr = value;
                    }
                    if (name.equals("xmcyr")) {
                        // 项目参与人
                        xmcyr = value;
                    }
                    if (name.equals("xmsqr")) {
                        // 项目申请人
                        xmsqr = value;
                    }
                }
                logger_fedc85f2.error(String.valueOf("主表信息取值结束，如——————————" + "项目申请人：" + xmsqr));
                // 将申请人信息由代号转换为真实信息
                ResourceComInfo hr = I18nContextUtil.getBean(ResourceComInfo.class);
                BillFieldUtil unit = new BillFieldUtil();
                logger_fedc85f2.error(String.valueOf("开始 将申请人信息由代号转换为真实信息"));
                if (!xmsqr.equals("")) {
                    // 获取申请人姓名
                    sqrxm = hr.getResourcename(xmsqr);
                }
                if (!xmcyr.equals("")) {
                    // 获取项目参与人姓名
                    xmcyr = hr.getResourcename(xmcyr);
                }
                if (!xmzrr.equals("")) {
                    // 获取项目责任人姓名
                    xmzrr = hr.getResourcename(xmzrr);
                }
                if (!xmjsr.equals("")) {
                    // 获取项目接收人姓名
                    xmjsr = hr.getResourcename(xmjsr);
                }
                logger_fedc85f2.error(String.valueOf("代号转为真实信息结束" + "\t" + "项目申请人" + sqrxm));
                OA_KSJXCL_SERVICEStub.OA_XCLLXSQ_HEADER_TYPE param_data = new OA_KSJXCL_SERVICEStub.OA_XCLLXSQ_HEADER_TYPE();
                OA_KSJXCL_SERVICEStub.ArrayOfOA_XCLLXSQ_HEADER_TYPE param_datas = new OA_KSJXCL_SERVICEStub.ArrayOfOA_XCLLXSQ_HEADER_TYPE();
                OA_KSJXCL_SERVICEStub.OA_XCLLXSQ resultin = new OA_KSJXCL_SERVICEStub.OA_XCLLXSQ();
                try {
                    // 主表信息赋值
                    logger_fedc85f2.error(String.valueOf("主表信息开始赋值"));
//                    param_data.setREQUESTID(Integer.parseInt(requestId));
//                    param_data.setID(Integer.parseInt(id));
                    param_data.setLCBH(lcbh);
                    param_data.setSKH("GDBJ/BQ-0040A");
                    param_data.setSQBM(sqbm);
                    param_data.setTBRQ(tbrq);
                    param_data.setWLH(wlh);
                    param_data.setXMLB(xmlb);
                    param_data.setXMYJWCSJ(xmyjwcsj);
                    param_data.setCPMC(cpmc);
                    param_data.setXMZRR(xmzrr);
                    param_data.setSZSFTBJX(szsftbjx);
                    param_data.setYYSM(yysm);
                    param_data.setXCLWLXX(xclwlxx);
                    param_data.setRZNR(rznr);
                    param_data.setXQLY(xqly);
                    param_data.setYQCP(yqcp);
                    param_data.setYQJJ(yqjj);
                    param_data.setXQXMDH(xqxmdh);
                    param_data.setXQCLSL(xqclsl);
                    param_data.setXCLMC(xclmc);
                    param_data.setXQDHSJ(xqdhsj);
                    param_data.setXCLXHGG(clxhgg);
                    param_data.setXQXMDDH(xuqxmmc);
                    param_data.setJYGYS1(jygys1);
                    param_data.setJYGYS2(jygys2);
                    param_data.setJYGYS3(jygys3);
                    param_data.setJYGYS4(jygys4);
                    param_data.setJYGYS5(jygys5);
                    param_data.setJYGYS6(jygys6);
                    param_data.setWLTZZ(wltzz);
                    param_data.setXMJSR(xmjsr);
                    param_data.setXMCYR(xmcyr);
                    // 项目申请人 ， 通过sqrxm中转
                    param_data.setXMSQR(sqrxm);
                    try {
                        logger_fedc85f2.error(String.valueOf("主表强制转换开始"));
                        param_data.setSBGZTZ(Double.parseDouble(sbgztz));
                        param_data.setCLTZ(Double.parseDouble(cltz));
                        param_data.setRGTZ(Double.parseDouble(rgtz));
                        param_data.setSDTZ(Double.parseDouble(sdtz));
                        param_data.setQTTZ(Double.parseDouble(qttz));
                        param_data.setHJZTZ(Double.parseDouble(hjztz));
                        // 周期
                        param_data.setZQ(Integer.parseInt(zq));
                        // 需求到货周期
                        param_data.setXQDHZQ(Integer.parseInt(xqdhzq));
                    } catch (NumberFormatException e) {
                        System.err.println(e.toString());
                        logger_fedc85f2.error(String.valueOf("主表强制转换传值报错 " + e.toString()));
                    }
                } catch (NumberFormatException e) {
                    System.err.println(e.toString());
                    logger_fedc85f2.error(String.valueOf("主表强制转换传值报错 " + e.toString()));
                }
                try {
                    // 封装信息
                    logger_fedc85f2.error(String.valueOf("开始封装表单信息 "));
                    param_datas.addOA_XCLLXSQ_HEADER_TYPE(param_data);
                    resultin.setITFID("IFTIF001");
                    resultin.setWERKS("A000");
                    resultin.setDATAS(param_datas);
                } catch (NumberFormatException e) {
                    System.err.println(e.toString());
                    logger_fedc85f2.error(String.valueOf("封装报错 " + e.toString()));
                }
                logger_fedc85f2.error(String.valueOf("调用接口开始0 "));
                logger_fedc85f2.error(String.valueOf("调用接口完成RequestId--" + requestId + "--项目责任人--" + xmzrr + "--流程编号--" + lcbh + "新材料名称" + xclmc + "--xclmc--" + sqbm));
                String sta = "";
                String meg = "";
                CallMesNewMaterialProjectService mes = new CallMesNewMaterialProjectService();
                // 修改过
                mes.setOainput(resultin);
                String[] rtInfo = mes.call();
                logger_fedc85f2.error(String.valueOf("调用接口完成RequestId--" + rtInfo[0] + "--Istat--" + rtInfo[1] + "--Srmsage--" + rtInfo[2]));
                sta = rtInfo[1];
                meg = rtInfo[2].replace("'", "’");
                String tablename = "";
                String wfid = request.getWorkflowid();
//                tablename = unit.getTablename(wfid);
                tablename = request.getRequestManager().getBillTableName();
                String logsql = "update e10_core_business.dbo." + tablename + " set sta ='" + sta + "', meg = '" + meg + "' where id = " + requestId;
                logger_fedc85f2.error(String.valueOf("logsql:" + logsql));
                RecordSet rs = I18nContextUtil.getBean(RecordSet.class);
                String poolname = CONN_TYPE.workflow.getType();
                // TODO E10执行sql方法第二参数必须指定源，默认使用流程源，单体客户无需修改，微服务/组合客户需根据查询表所属服务切换源，或使用外部数据源
                boolean b = rs.executeSql(logsql, poolname);
                logger_fedc85f2.error(String.valueOf("logsql:" + logsql + "执行结果：" + b));
                logger_fedc85f2.error(String.valueOf("HTGD_SW_OaBackAction-Request: " + requestId + "完成"));
                if (!sta.equals("S")) {
                    request.getRequestManager().setMessageid("100001");
                    request.getRequestManager().setMessagecontent(meg);
                    return  WeaResult.fail(500, "OaMesNewMaterialProjectAction meg"+ meg, getResultMapForAction(weaverResultMap, "result",meg, request.getRequestManager()));

                }
                System.out.println(meg);
            } catch (Exception e) {
                System.err.println(e.toString());
                logger_fedc85f2.error(String.valueOf("调用接口报错 " + e.toString()));
                return  WeaResult.fail(500, "OaMesNewMaterialProjectAction err"+ e, getResultMapForAction(weaverResultMap, "result",e.getMessage(), request.getRequestManager()));

            }
            return WeaResult.success(getResultMapForAction(weaverResultMap, "result", Action.SUCCESS, request.getRequestManager()));
        } catch (Exception e) {
            e.printStackTrace();
            logger_fedc85f2.error("OaMesNewMaterialProjectAction e: {}", e.getMessage());
            return  WeaResult.fail(500, "OaMesNewMaterialProjectAction e: {}"+ e, getResultMapForAction(weaverResultMap, "result",e.getMessage(), request.getRequestManager()));
        }
    }

    Map<String, Object> getResultMapForAction(Map<String, Object> map, String key, Object value, RequestManager requestManager) {
        if (key != null && !key.isEmpty()) {
            map.put(key, value);
        }
        String msgContent = requestManager.getMessagecontent();
        if (msgContent != null && !msgContent.isEmpty()) {
            map.put("msgContent", msgContent);
        }
        String msgId = requestManager.getMessageid();
        if (msgId != null && !msgId.isEmpty()) {
            map.put("msgId", msgId);
        }
        return map;
    }
}
